#!/usr/bin/env python

"""
Simple built-in classes and functions.

Copyright (C) 2005, 2006, 2007, 2008 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along with
this program.  If not, see <http://www.gnu.org/licenses/>.
"""

class object:
    def __init__(self): pass
    def __bool__(self): pass
    def __iadd__(self, other): pass

class basestring(object):
    def __init__(self, x=None): pass
    def __getitem__(self, index): pass
    def __getslice__(self, start, end=None): pass
    def __iadd__(self, other): pass
    def __add__(self, other): pass
    def __radd__(self, other): pass
    def __mul__(self, other): pass
    def __radd__(self, other): pass
    def __mod__(self, other): pass
    def __lt__(self, other): pass
    def __gt__(self, other): pass
    def __le__(self, other): pass
    def __ge__(self, other): pass
    def __eq__(self, other): pass
    def __ne__(self, other): pass
    def __len__(self): pass
    def __str__(self): pass
    def __bool__(self): pass
    def join(self, l): pass

class bool(object):
    def __bool__(self): pass
    def __str__(self): pass

class buffer(object):
    def __init__(self, size): pass
    def append(self, s): pass
    def __str__(self): pass

class complex(object):
    def __init__(self, real, imag=None): pass

class dict(object):
    def __init__(self, *args): pass
    def __setitem__(self, key, value): pass
    def __getitem__(self, key): pass

class file(object):
    def write(self, s): pass

class float(object):
    def __init__(self, number_or_string=None): pass
    def __iadd__(self, other): pass
    def __isub__(self, other): pass
    def __add__(self, other): pass
    def __radd__(self, other): pass
    def __sub__(self, other): pass
    def __rsub__(self, other): pass
    def __mul__(self, other): pass
    def __rmul__(self, other): pass
    def __div__(self, other): pass
    def __rdiv__(self, other): pass
    def __floordiv__(self, other): pass
    def __rfloordiv__(self, other): pass
    def __mod__(self, other): pass
    def __pow__(self, other): pass
    def __rpow__(self, other): pass
    def __lt__(self, other): pass
    def __gt__(self, other): pass
    def __le__(self, other): pass
    def __ge__(self, other): pass
    def __eq__(self, other): pass
    def __ne__(self, other): pass
    def __neg__(self): pass
    def __pos__(self): pass
    def __str__(self): pass
    def __bool__(self): pass

class frozenset(object):
    def __init__(self, iterable): pass

class function(object):
    pass

class int(object):
    def __init__(self, number_or_string=None): pass
    def __iadd__(self, other): pass
    def __isub__(self, other): pass
    def __add__(self, other): pass
    def __radd__(self, other): pass
    def __sub__(self, other): pass
    def __rsub__(self, other): pass
    def __mul__(self, other): pass
    def __rmul__(self, other): pass
    def __div__(self, other): pass
    def __rdiv__(self, other): pass
    def __floordiv__(self, other): pass
    def __rfloordiv__(self, other): pass
    def __mod__(self, other): pass
    def __pow__(self, other): pass
    def __and__(self, other): pass
    def __rand__(self, other): pass
    def __or__(self, other): pass
    def __ror__(self, other): pass
    def __xor__(self, other): pass
    def __rxor__(self, other): pass
    def __lt__(self, other): pass
    def __gt__(self, other): pass
    def __le__(self, other): pass
    def __ge__(self, other): pass
    def __eq__(self, other): pass
    def __ne__(self, other): pass
    def __neg__(self): pass
    def __pos__(self): pass
    def __str__(self): pass
    def __bool__(self): pass

class list(object):
    def __init__(self, args=()): pass
    def __getitem__(self, index): pass
    def __setitem__(self, index, value): pass
    def __getslice__(self, start, end=None): pass
    def __setslice__(self, start, end, slice): pass
    def append(self, value): pass
    def __len__(self): pass
    def __add__(self, other): pass
    def __iadd__(self, other): pass
    def __str__(self): pass
    def __iter__(self): pass
    def __bool__(self): pass

class long(object):
    def __init__(self, number_or_string=None): pass
    def __iadd__(self, other): pass
    def __isub__(self, other): pass
    def __add__(self, other): pass
    def __radd__(self, other): pass
    def __sub__(self, other): pass
    def __rsub__(self, other): pass
    def __mul__(self, other): pass
    def __rmul__(self, other): pass
    def __div__(self, other): pass
    def __rdiv__(self, other): pass
    def __floordiv__(self, other): pass
    def __rfloordiv__(self, other): pass
    def __and__(self, other): pass
    def __rand__(self, other): pass
    def __or__(self, other): pass
    def __ror__(self, other): pass
    def __xor__(self, other): pass
    def __rxor__(self, other): pass
    def __lt__(self, other): pass
    def __gt__(self, other): pass
    def __le__(self, other): pass
    def __ge__(self, other): pass
    def __eq__(self, other): pass
    def __ne__(self, other): pass
    def __neg__(self): pass
    def __pos__(self): pass
    def __str__(self): pass
    def __bool__(self): pass

class set(object):
    def __init__(self, iterable): pass

class slice(object):
    def __init__(self, start_or_end, end=None, step=None): pass

class str(basestring):
    pass

class type(object):
    pass

class tuple(object):
    def __init__(self, args): pass
    def __getitem__(self, index): pass
    def __getslice__(self, start, end=None): pass
    def __len__(self): pass
    def __add__(self, other): pass
    def __str__(self): pass
    def __iter__(self): pass
    def __bool__(self): pass

class unicode(basestring):
    pass

class xrange(object):
    def __init__(self, start_or_end, end=None, step=1): pass
    def __iter__(self): pass
    def next(self): pass

# Exceptions and warnings.

class BaseException(object):
    def __init__(self, *args): pass

class Exception(BaseException): pass
class Warning(object): pass

class ArithmeticError(Exception): pass
class AssertionError(Exception): pass
class AttributeError(Exception): pass
class DeprecationWarning(Exception): pass
class EOFError(Exception): pass
class EnvironmentError(Exception): pass
class FloatingPointError(Exception): pass
class FutureWarning(Warning): pass
class GeneratorExit(Exception): pass
class IndexError(Exception): pass
class IOError(Exception): pass
class ImportError(Exception): pass
class ImportWarning(Warning): pass
class IndentationError(Exception): pass
class IndexError(Exception): pass
class KeyError(Exception): pass
class KeyboardInterrupt(Exception): pass
class LookupError(Exception): pass
class MemoryError(Exception): pass
class NameError(Exception): pass
class NotImplementedError(Exception): pass
class OSError(Exception): pass
class OverflowError(Exception): pass
class PendingDeprecationWarning(Warning): pass
class ReferenceError(Exception): pass
class RuntimeError(Exception): pass
class RuntimeWarning(Warning): pass
class StandardError(Exception): pass
class StopIteration(Exception): pass
class SyntaxError(Exception): pass
class SyntaxWarning(Warning): pass
class SystemError(Exception): pass
class SystemExit(Exception): pass
class TabError(Exception): pass
class TypeError(Exception): pass
class UnboundLocalError(Exception): pass
class UnicodeDecodeError(Exception): pass
class UnicodeEncodeError(Exception): pass
class UnicodeError(Exception): pass
class UnicodeTranslateError(Exception): pass
class UnicodeWarning(Warning): pass
class UserWarning(Warning): pass
class ValueError(Exception): pass
class ZeroDivisionError(Exception): pass

# Various types.

class EllipsisType(object): pass
class NotImplementedType: pass

# Special values.

True = bool()
False = bool()
Ellipsis = EllipsisType()
NotImplemented = NotImplementedType()

# General functions.
# NOTE: Some of these are actually provided by classes in CPython.
# NOTE: We may refuse to support some of these in practice, such as...
# NOTE: super, reload.

def __import__(name, globals=None, locals=None, fromlist=None, level=-1): pass
def abs(number): pass
def all(iterable): pass
def any(iterable): pass
def callable(obj): pass
def chr(i): pass
def classmethod(function): pass
def cmp(x, y): pass
def compile(source, filename, mode, flags=None, dont_inherit=None): pass
def delattr(obj, name): pass
def dir(obj=None): pass
def divmod(x, y): pass
def enumerate(iterable): pass
def eval(source, globals=None, locals=None): pass
def execfile(filename, globals=None, locals=None): pass
def filter(function, sequence): pass
def getattr(obj, name, default=None): pass
def globals(): pass
def hasattr(obj, name): pass
def hash(obj): pass
def help(*args, **kw): pass
def hex(number): pass
def id(obj): pass
def input(prompt=None): pass
def isinstance(obj, cls_or_tuple): pass
def issubclass(obj, cls_or_tuple): pass
def iter(collection_or_callable, sentinel=None): pass
def len(obj): pass
def locals(): pass
def map(function, *args): pass
def max(*args, **kw): pass
def min(*args, **kw): pass
def oct(number): pass
def open(name, mode=None, buffering=None): pass
def ord(c): pass
def pow(x, y, z=None): pass
def property(fget=None, fset=None, fdel=None, doc=None): pass
def range(start_or_end, end=None, step=None): pass
def raw_input(prompt=None): pass
def reduce(function, sequence, initial=None): pass
def reload(module): pass
def repr(obj): pass
def reversed(sequence): pass
def round(number, ndigits=None): pass
def setattr(obj, name, value): pass
def sorted(iterable, cmp=None, key=None, reverse=False): pass
def staticmethod(function): pass
def sum(sequence, start=0): pass
def super(*args): pass
def unichr(i): pass
def vars(obj=None): pass
def zip(*args): pass

# vim: tabstop=4 expandtab shiftwidth=4
